/**
 * LibMSALObj
 *
 * Created by Your Name
 * Copyright (c) 2019 Your Company. All rights reserved.
 */

#import "ComAgilentLibmsalobjModule.h"
#import "TiBase.h"
#import "TiHost.h"
#import "TiUtils.h"
#import <MSAL/MSAL.h>
#import "TiApp.h"

@implementation ComAgilentLibmsalobjModule

NSString* kRedirectUri ;
NSString* kClientID = @"4ff6c8db-6e00-4b08-b9d1-939ec5dc3e3e";
NSString* kAuthority = @"https://login.microsoftonline.com/a9c0bc09-8b46-4206-9351-2ba12fb4a5c0"; // directory id
NSString* accessToken;
MSALPublicClientApplication *applicationContext;
MSALWebviewParameters *webViewParamaters;

#pragma mark Internal

// This is generated for your module, please do not change it
- (id)moduleGUID
{
  return @"b5f36bf8-5e45-42d9-b0e7-290809e57862";
}

// This is generated for your module, please do not change it
- (NSString *)moduleId
{
  return @"com.agilent.libmsalobj";
}

-(void)_configure {
    [super _configure];
   [[TiApp app] registerApplicationDelegate:self];
}

- (BOOL)application:(UIApplication *)app
            openURL:(NSURL *)url
            options:(NSDictionary<UIApplicationOpenURLOptionsKey,id> *)options
{
    
     NSLog(@"handleMSALResponsehandleMSALResponse %@", url);
    return [MSALPublicClientApplication handleMSALResponse:url
                                         sourceApplication:options[UIApplicationOpenURLOptionsSourceApplicationKey]];
}
#pragma mark Lifecycle

- (void)startup
{
  // This method is called when the module is first loaded
  // You *must* call the superclass
  [super startup];
    kRedirectUri = @"msauth.com.agilent.devmgmpintune://auth";

  DebugLog(@"[DEBUG] %@ loaded", self);
}

#pragma Public APIs

- (MSALPublicClientApplication *)createPublicClientApplication:(NSError * _Nullable __autoreleasing * _Nullable)error
{
    NSString *clientId = kClientID;
    NSURL *authorityUrl = [NSURL URLWithString:kAuthority];
    MSALAuthority *authority = [MSALAuthority authorityWithURL:authorityUrl error:nil];
    MSALAuthority *authority_q = [MSALAADAuthority authorityWithURL:authorityUrl error:nil];
    MSALPublicClientApplicationConfig *pcaConfig = [[MSALPublicClientApplicationConfig alloc] initWithClientId:clientId
                                                                                                   redirectUri:kRedirectUri
                                                                                                     authority:authority_q];
    
    pcaConfig.knownAuthorities = @[pcaConfig.authority];
    
//    MSALPublicClientApplication *application = [[MSALPublicClientApplication alloc] initWithConfiguration:pcaConfig error:error];
    
    NSLog(@"application %@", pcaConfig.authority.url);
    
    NSError *msalError = nil;

    MSALPublicClientApplicationConfig *config = [[MSALPublicClientApplicationConfig alloc] initWithClientId:clientId];
    MSALPublicClientApplication *application = [[MSALPublicClientApplication alloc] initWithConfiguration:config error:&msalError];

    
    return application;
}

- (void) acquireToken {
    NSError *msalError = nil;
        
    NSArray<NSString *> *scopes = @[@"https://lqhan11hd2-agilent.msappproxy.net/user_impersonation"];
//
    MSALPublicClientApplication *application_1= [self createPublicClientApplication:&msalError];
    
        
    #if TARGET_OS_IPHONE
//        UIViewController *viewController = ...; // Pass a reference to the view controller that should be used when getting a token interactively
    UIViewController *viewController = [[UIViewController alloc] init];
    MSALWebviewParameters *webParameters = [[MSALWebviewParameters alloc] initWithParentViewController:viewController];
    #else
        MSALWebviewParameters *webParameters = [MSALWebviewParameters new];
    #endif
        
    MSALInteractiveTokenParameters *interactiveParams = [[MSALInteractiveTokenParameters alloc] initWithScopes:scopes webviewParameters:webParameters];
//    interactiveParams.promptType = MSALPromptTypeSelectAccount;
    
     NSLog(@"contapplicationext %@", application_1);
    [application_1 acquireTokenWithParameters:interactiveParams completionBlock:^(MSALResult *result, NSError *error) {
        if (!error)
        {
            // You'll want to get the account identifier to retrieve and reuse the account
            // for later acquireToken calls
            NSString *accountIdentifier = result.account.identifier;

            NSString *accessToken = result.accessToken;
        }
        else
        {
            // Check the error
            NSLog(@"error %@", error);
        }
    }];
}



- (NSString *)example:(id)args
{
  // Example method. 
  // Call with "MyModule.example(args)"
  return @"hello world";
}

- (NSString *)exampleProp
{
  // Example property getter. 
  // Call with "MyModule.exampleProp" or "MyModule.getExampleProp()"
  return @"Titanium rocks!";
}

- (void)setExampleProp:(id)value
{
  // Example property setter. 
  // Call with "MyModule.exampleProp = 'newValue'" or "MyModule.setExampleProp('newValue')"
}

@end
